django/ippo/urls.py
from django.conf.urls import url, include
from django.contrib import admin
from django.urls import path
from django.conf import settings
from django.conf.urls.static import static
from django.views.generic import RedirectView
from documents.views import protected_view
from ecm.views import protected_view as ecm_view
from django.views.static import serve

urlpatterns = [
                  url(r'^favicon\.ico$', RedirectView.as_view(url='/static/main/images/ippo.ico')),
                  path('admin/', admin.site.urls),
                  path('', include('main.urls')),
                  path('diplomas/', include('diplomas.urls')),
                  path('appointments/', include('appointment.urls')),
                  path('news/', include('news.urls')),
                  url(r'^ckeditor/', include('ckeditor_uploader.urls')),
                  path('subjects/', include('subjects.urls')),
                  path('documents/', include('documents.urls')),
                  path('schedule/', include('schedule.urls')),
                  path('people/', include('people.urls')),
                  path('library/', include('library.urls')),
                  url(r'^select2/', include('django_select2.urls')),
              ] + static(
    settings.STATIC_URL,
    document_root=settings.STATIC_ROOT
) + static(
    settings.MEDIA_URL,
    document_root=settings.MEDIA_ROOT
)
#
# if settings.DEBUG:
#     urlpatterns += [
#         url(
#             r"^{}/(?P<path>.*)$".format(settings.MEDIA_URL),
#             serve,
#             {"document_root": settings.MEDIA_ROOT, "show_indexes": True}
#         ),
#         url(
#             r"^{}/(?P<path>.*)$".format(settings.PROTECTED_MEDIA_URL),
#             serve,
#             {"document_root": settings.PROTECTED_MEDIA_ROOT, "show_indexes": True}
#         ),
#     ]
# else:
urlpatterns += [
    # url(
    #     r"^{}/(?P<path>.*)$".format(settings.PROTECTED_MEDIA_URL),
    #     protected_view
    # ),
    url(r'^protected/ecm/(?P<path>.*)$', ecm_view),
    url(r'^protected/(?P<path>.*)$', protected_view),
]

django/schedule/urls.py
from django.urls import path
from django.conf.urls import url

from .views import *

app_name = 'schedule'

urlpatterns = [
    path('', index, name="index"),
    path('beta', index_beta, name="index_beta"),
    path('control', control, name="control"),
    path('parse/<int:pk>', parse, name="parse"),
    path('parse_baks/', parse_baks, name="parse_baks"),
    path('week/<str:category>/<int:idx>/<str:week_type>', week, name="week"),
    path('clear/<str:category>', clear, name="clear"),
    path('poll_state', poll_state, name="poll_state"),
    path('download', download, name="download"),
    path('identify', identify, name="identify"),
    path('celery_test', celery_test, name="celery_test"),
    url(r'^room-autocomplete/$', RoomAutocomplete.as_view(), name='room-autocomplete'),
    url(r'^teacher-autocomplete/$', TeacherAutocomplete.as_view(), name='teacher-autocomplete'),
    url(r'^group-autocomplete/$', GroupAutocomplete.as_view(), name='group-autocomplete'),
]

django/ecm/models.py
from django.core.validators import FileExtensionValidator
from django.db import models
from django.utils.timezone import now

from main import storage
from people.models import Worker


class Category(models.Model):
    name = models.CharField(max_length=128, unique=True, verbose_name='Название')

    class Meta:
        verbose_name = "Тип"
        verbose_name_plural = "Типы"
        ordering = ['name']

    def __str__(self):
        return self.name


class Document(models.Model):
    DIRECTION_CHOICES = [('вхд', 'Входящий'), ('исх', 'Исходящий'), ('внт', 'Внутренний')]
    direction = models.CharField(choices=DIRECTION_CHOICES, max_length=3, verbose_name='Вид')
    category = models.ForeignKey(Category, models.CASCADE, verbose_name='Тип')
    creation_date = models.DateField(default=now, verbose_name='Дата создания')
    register_date = models.DateField(null=True, blank=True, verbose_name='Дата регистрации')
    to_whom = models.ManyToManyField(Worker, related_name='recipient', verbose_name='Кому')
    from_whom = models.ForeignKey(Worker, on_delete=models.SET_NULL, null=True, related_name='initiator',
                                  verbose_name='От кого')
    executor = models.ForeignKey(Worker, on_delete=models.SET_NULL, null=True, blank=True, related_name='executor',
                                 verbose_name='Исполнитель')
    pdf_file = models.FileField(upload_to=storage.upload_ecm_document, storage=storage.ProtectedFileSystemStorage(),
                                validators=[FileExtensionValidator(allowed_extensions=['pdf'])], null=True, blank=True,
                                verbose_name='PDF')
    docx_file = models.FileField(upload_to=storage.upload_ecm_document, storage=storage.ProtectedFileSystemStorage(),
                                 validators=[FileExtensionValidator(allowed_extensions=['docx'])], null=True,
                                 blank=True, verbose_name='DOCX')
    code = models.CharField(max_length=32, unique_for_month=True, verbose_name='Код', blank=True)

    class Meta:
        verbose_name = "Документ"
        verbose_name_plural = "Документы"
        ordering = ['-creation_date']

    def __str__(self):
        return f'{self.get_direction_display()} {self.category} {self.creation_date}'

    def save(self, *args, **kwargs):
        temp_pdf_file = self.pdf_file
        temp_docx_file = self.docx_file
        if not self.id:
            self.pdf_file = None
            self.docx_file = None
            super(Document, self).save(*args, **kwargs)
            code = self.direction + str(self.creation_date.strftime("%y%m"))

            # map_dir = enumerate(self.DIRECTION_CHOICES, 1)
            # for m in map_dir:
            #     if self.direction in m[1][0]:
            #         code += str(m[0])

            suffix = 0
            while Document.objects.filter(code=code + str(suffix).zfill(2)):
                suffix += 1

            self.code = code + str(suffix).zfill(2)
            super(Document, self).save(*args, **kwargs)
            self.pdf_file = temp_pdf_file
            self.docx_file = temp_docx_file
            super(Document, self).save(*args, **kwargs)
        else:
            super(Document, self).save(*args, **kwargs)

django/schedule/views.py
import json
import shutil
from datetime import timedelta, date
from pathlib import Path

from celery.result import AsyncResult
from dal import autocomplete
from django.conf import settings
from django.contrib.auth.decorators import login_required
from django.http import HttpResponse, HttpResponseRedirect
from django.shortcuts import render, redirect

from people.models import Group
from schedule.tasks import download_schedule_files, identify_schedule_files, parse_schedule_files, parse_baks_task, \
    parse_mag_schedule_files
from .models import ScheduleFile, Period, Teacher, Room
from .forms import SelectScheduleForm


def daterange(start_date, end_date):
    for n in range(int((end_date - start_date).days)):
        yield start_date + timedelta(n)


def index(request):
    start_date = date(2019, 9, 1)
    end_date = date(2019, 12, 31)
    week_number = ''
    for single_date in daterange(start_date, end_date):
        if date.today() == single_date:
            # print(f'{single_date.strftime("%Y.%m.%d")} {single_date.isocalendar()[1] - 6}')
            week_number = single_date.isocalendar()[1] - 35

    if not week_number:
        week_number = 99

    group_list = Group.objects.filter(sched_period_groups__isnull=False)
    teacher_list = Teacher.objects.filter(sched_period_teachers__isnull=False)
    room_list = Room.objects.filter(sched_period_rooms__isnull=False)

    updated = ScheduleFile.objects.first().uploaded_at.strftime("%d.%m.%y")

    context = {
        "group_list": group_list,
        "teacher_list": teacher_list,
        "room_list": room_list,
        "week_number": week_number,
        "updated": updated
    }
    return render(request, "schedule/index.html", context)


def index_beta(request):
    if request.method == 'POST':
        form = SelectScheduleForm(request.POST)
        if form.is_valid():
            category = form.data.get('category')
            group = form.cleaned_data.get('group')
            teacher = form.cleaned_data.get('teacher')
            room = form.cleaned_data.get('room')
            periods = {}
            if group:
                if category == 'odd':
                    even = 0
                else:
                    even = 1
                periods = Period.objects.filter(file__category='class', even=even, group__name=group)
                periods = periods.values_list('day', 'number', 'name', 'teachers__name', 'rooms__name')

            context = {
                'form': SelectScheduleForm({'category': 'even'}),
                'periods': periods,
                'group': group,
                'category': category,
            }
            return render(request, "schedule/index_beta.html", context)
    else:
        form = SelectScheduleForm({'category': 'even'})
    context = {
        'form': form,
    }
    return render(request, "schedule/index_beta.html", context)


@login_required
def control(request):
    file_list = ScheduleFile.objects.all().order_by('category', 'institute', 'grade', 'course')
    # file_list = ScheduleFile.objects.all()
    context = {"file_list": file_list}
    return render(request, "schedule/control.html", context)


@login_required
def clear(request, category):
    # Teacher.objects.all().delete()
    # Room.objects.all().delete()
    if category == 'files':
        ScheduleFile.objects.all().delete()
        folder = Path(settings.MEDIA_ROOT) / 'schedule_files'
        try:
            shutil.rmtree(folder)
        except OSError as e:
            print("Error: %s - %s." % (e.filename, e.strerror))
    elif category == 'periods':
        Period.objects.all().delete()
    return redirect("/schedule/control")


def celery_test(request):
    res = download_schedule_files.delay()

    return redirect("/schedule/control")


def poll_state(request):
    if 'job' in request.GET:
        job_id = request.GET['job']
    else:
        return HttpResponse('No job id given.')
    job = AsyncResult(job_id)
    data = job.result or job.state
    return HttpResponse(json.dumps(data), content_type='application/json')


@login_required
def download(request):
    download_schedule_files.delay()
    # job = download_schedule_files.delay()
    # # return HttpResponseRedirect(reverse('schedule:poll_state') + '?job=' + job.id)
    # context = {
    #     'job_id': job.id,
    # }
    return render(request, "schedule/control.html")


@login_required
def identify(request):
    identify_schedule_files.delay()
    return HttpResponse('wait 1 minute and continue')


# todo: refactor
def week(request, category, idx, week_type):
    print(week_type)
    if week_type == 'exam':
        period_quuryset = Period.objects.filter(file__category='exam').order_by('m_day', 'time')
        if category == "g":
            p = period_quuryset.filter(group=idx)
        elif category == "t":
            p = period_quuryset.filter(teachers__id=idx)
        elif category == "r":
            p = period_quuryset.filter(rooms__id=idx)
        else:
            p = False
        if p:
            periods = p

            context = {
                "periods": periods,
                "category": category,
                "week_type": week_type,
                "upd_date": period_quuryset[0].file.uploaded_at.strftime("%d.%m.%y"),
            }
            return render(request, "schedule/week.html", context)
    elif week_type == 'test':
        periods = {}
        for d in range(1, 7):
            periods[d] = {}
            for n in range(1, 7):
                periods[d][n] = {}
                if category == "g":
                    p = Period.objects.filter(file__category='test', day=d, number=n, group=idx)
                elif category == "t":
                    p = Period.objects.filter(file__category='test', day=d, number=n, teachers__id=idx)
                elif category == "r":
                    p = Period.objects.filter(file__category='test', day=d, number=n, rooms__id=idx)
                else:
                    p = False
                if p:
                    if category == "t" or category == "r":
                        group_list = list(p.values_list("group__name", flat=True))
                        periods[d][n]["groups"] = " ".join([str(gr) for gr in group_list])
                        p = p.order_by("day", "number").distinct("day", "number")
                    name_list = list(p.values_list("name", flat=True))
                    periods[d][n]["name"] = " ".join([str(name) for name in name_list])
                    category_list = list(p.values_list("category", flat=True))
                    periods[d][n]["category"] = " ".join(
                        [str(cat) for cat in category_list]
                    )
                    room_list = list(p.values_list("rooms__name", flat=True))
                    periods[d][n]["room"] = " ".join([str(room) for room in room_list])
                    if periods[d][n]["room"] == "None":
                        periods[d][n]["room"] = ""
                    teacher_list = list(p.values_list("teachers__name", flat=True))
                    periods[d][n]["teacher"] = " ".join(
                        [str(teacher) for teacher in teacher_list]
                    )
                    if periods[d][n]["teacher"] == "None":
                        periods[d][n]["teacher"] = ""
        context = {
            "periods": periods,
            "category": category
        }
        return render(request, "schedule/week.html", context)
    elif week_type == 'odd' or week_type == 'even':
        template = "schedule/week.html"
        if week_type == 'odd':
            even = 0
        else:
            even = 1
        periods = {}
        for d in range(1, 7):
            periods[d] = {}
            max_numbers = 7
            if category == "g":
                temp = Period.objects.filter(file__category='class', group=idx)
                grade = temp.first().file.grade
                if grade == 'm':
                    max_numbers = 10
                    template = "schedule/week_mag_class.html"

            for n in range(1, max_numbers):
                periods[d][n] = {}
                if category == "g":
                    p = Period.objects.filter(file__category='class', day=d, number=n, even=even, group=idx)
                elif category == "t":
                    p = Period.objects.filter(file__category='class', day=d, number=n, even=even, teachers__id=idx)
                elif category == "r":
                    p = Period.objects.filter(file__category='class', day=d, number=n, even=even, rooms__id=idx)
                else:
                    p = False
                if p:
                    if category == "t" or category == "r":
                        group_list = list(p.values_list("group__name", flat=True))
                        periods[d][n]["groups"] = " ".join([str(gr) for gr in group_list])
                        p = p.order_by("day", "number").distinct("day", "number")
                    name_list = list(p.values_list("name", flat=True))
                    periods[d][n]["name"] = " ".join([str(name) + '\n' for name in name_list])
                    category_list = list(p.values_list("category", flat=True))
                    periods[d][n]["category"] = " ".join(
                        [str(cat) + '\n' for cat in category_list]
                    )
                    room_list = list(p.values_list("rooms__name", flat=True))
                    periods[d][n]["room"] = " ".join([str(room) + '\n' for room in room_list])
                    if periods[d][n]["room"] == "None":
                        periods[d][n]["room"] = ""
                    teacher_list = list(p.values_list("teachers__name", flat=True))
                    periods[d][n]["teacher"] = " ".join(
                        [str(teacher) + '\n' for teacher in teacher_list]
                    )
                    if periods[d][n]["teacher"] == "None":

django/schedule/templates/schedule/control.html
{% extends 'main/base.html' %}
{% load static %}
{% block css %}
  <link rel="stylesheet" href="{% static "schedule/css/schedule-control.css" %}">
{% endblock %}
{% block title %}Управление{% endblock %}
{% load django_bootstrap_breadcrumbs %}
{% block breadcrumbs %}
  {{ block.super }}
  {% breadcrumb 'Расписание' "schedule:index" %}
  {% breadcrumb 'Управление' "schedule:control" %}
{% endblock %}
{% block content %}
  {% render_breadcrumbs %}
  <section class="container-fluid flex-grow">
    <h3>Управление</h3>
    <div id="progress-wrapper">
      <div class="progress">
        <div class="progress-bar" role="progressbar" style="width: 0%;" aria-valuenow="0" aria-valuemin="0"
             aria-valuemax="100">0
        </div>
      </div>
    </div>
    <br>
    <a class="btn btn-outline-primary" href="{% url "schedule:clear" "files" %}" role="button">clear files</a>
    <a class="btn btn-outline-primary" href="{% url "schedule:clear" "periods"%}" role="button">clear periods</a>
    <a class="btn btn-outline-primary" href="{% url "schedule:download" %}" role="button">Скачать файлы</a>
    <a class="btn btn-outline-primary" href="{% url "schedule:identify" %}" role="button">Определить файлы</a>
    <a class="btn btn-outline-primary" href="{% url "schedule:celery_test" %}" role="button">celery test</a>
    <a class="btn btn-outline-primary" href="{% url "schedule:parse_baks" %}" role="button">parse_baks</a>
    {% regroup file_list by get_category_display as grouped_list %}
    <ul>
      {% for category in grouped_list %}
        <li>
          <h6>{{ category.grouper }}</h6>
          <ul>
            {% for file in category.list %}
              <li><a href="parse/{{ file.id }}">Распарсить </a><a href="{{ file.file.url }}"> <i
                  class="far fa-file"></i></a> {{ file }} </li>
            {% endfor %}
          </ul>
        </li>
      {% endfor %}
    </ul>
  </section>
{% endblock %}
{% block js %}
  <script type="text/javascript">
      data = $.getJSON('{% url 'schedule:poll_state' %}?job={{ job_id }}', function (data) {
          return data;
      });

      for (let i = 0; i < 10; i++) {
          console.log(data);
          if (data['total']) {
              console.log('connencted');
              break;
          }
      }
      var i = 0;
      var total = 50;
      var current = 0;

      {#function makeProgress() {#}
      {#    if (i < total) {#}
      {#        $.getJSON('{% url 'schedule:poll_state' %}?job={{ job_id }}', function (data) {#}
      {#console.log('http://ippo.it/schedule/poll_state?job={{ job_id }}');#}
      {#            console.log(data);#}
      {#            if (data['current'] > 0) {#}
      {#                current = data['current'];#}
      {#                total = data['total'];#}
      {#                var siz = current * 100 / total;#}
      {#                $(".progress-bar").css("width", siz + "%").text(current);#}
      {#                $(".progress-bar").css("aria-valuemax", total);#}
      {#                i = current#}
      {#            }#}
      {#        });#}
      {##}
      {#    }#}
      {##}
      {#    // Wait for sometime before running this script again#}
      {#    setTimeout("makeProgress()", 100);#}

      #}#}
      {##}
      {#makeProgress();#}
  </script>
{% endblock %}

django/schedule/templates/schedule/index.html
{% extends 'main/base.html' %}
{% load static %}
{% block css %}
  <link rel="stylesheet" href="{% static "schedule/css/schedule.css" %}">
  <link rel="stylesheet" href="{% static "main/npm/css/selectize.default.css" %}">
{% endblock %}
{% block title %}Расписание{% endblock %}
{% load django_bootstrap_breadcrumbs %}
{% block breadcrumbs %}
  {{ block.super }}
  {% breadcrumb 'Расписание' "schedule:index" %}
{% endblock %}
{% block content %}
  {% render_breadcrumbs %}
  <section class="container-fluid flex-grow">
    <div class="row">
      <div class="col-lg">
        <select id="selector" placeholder="Группа, преподаватель или аудитория...">
          <option value="">Группа, преподаватель или аудитория...</option>
          <optgroup data-group="group" label="Группы">
            {% for group in group_list %}
              <option value="g-{{ group.id }}">{{ group }}</option>
            {% endfor %}
          </optgroup>
          <optgroup data-group="teacher" label="Преподаватели">
            {% for teacher in teacher_list %}
              <option value="t-{{ teacher.id }}">{{ teacher }}</option>
            {% endfor %}
          </optgroup>
          <optgroup data-group="room" label="Аудитории">
            {% for room in room_list %}
              <option value="r-{{ room.id }}">{{ room }}</option>
            {% endfor %}
          </optgroup>
        </select>
      </div>

      {#    <div class="col-sm-3">#}
      {#        <div id="switch" class="form-group">#}
      {#          <span>I</span>#}
      {#          <label class="switch">#}
      {#            <input id="sw_chb" type="checkbox">#}
      {#            <span class="slider round"></span>#}
      {#          </label>#}
      {#          <span>II</span>#}
      {#      </div>#}
      {#    </div>#}
      <div class="col-md" style="padding-top: 0.5em" id="switcher">
        <div class="form-check form-check-inline">
          <input class="form-check-input" type="radio" name="inlineRadioOptions" id="inlineRadio1"
                 value="odd" {% if week_number < 17 and not week_number|divisibleby:"2" %}checked{% endif %}>
          <label class="form-check-label" for="inlineRadio1">I</label>
        </div>
        <div class="form-check form-check-inline">
          <input class="form-check-input" type="radio" name="inlineRadioOptions" id="inlineRadio2"
                 value="even" {% if week_number < 17 and week_number|divisibleby:"2" %}checked{% endif %}>
          <label class="form-check-label" for="inlineRadio2">II</label>
        </div>
        <div class="form-check form-check-inline">
          <input class="form-check-input" type="radio" name="inlineRadioOptions" id="inlineRadio3"
                 value="test" {% if week_number == 17 %}checked{% endif %}>
          <label class="form-check-label" for="inlineRadio3">Зачёты</label>
        </div>
        <div class="form-check form-check-inline">
          <input class="form-check-input" type="radio" name="inlineRadioOptions" id="inlineRadio4"
                 value="exam" {% if week_number > 17 %}checked{% endif %}>
          <label class="form-check-label" for="inlineRadio4">Экзамены</label>
        </div>
      </div>
      <div class="col-sm" style="padding-top: 0.5em">
        Неделя: {% if week_number < 17 %} {{ week_number }}{% elif week_number == 17 %}
        {{ week_number }} зачёты {% elif  week_number > 17 and week_number < 21 %} {{ week_number }}
        экзамены {% else %} <i class="far fa-sun"></i> {% endif %}
      </div>
      <div class="col-sm" style="padding-top: 0.5em">
        Обновлено: {{ updated }}
      </div>
    </div>
  </section>

  <div class="row">
    <div class="col" id="out">
    </div>
  </div>
{% endblock %}
{% block js %}
  <script src="{% static "main/npm/js/selectize.min.js" %}"></script>
  <script src="{% static "schedule/js/schedule.js" %}"></script>
{% endblock %}

django/schedule/templates/schedule/index_beta.html
{% extends 'main/base.html' %}
{% load static %}
{#{% block css %}#}
{#  <link rel="stylesheet" href="{% static "schedule/css/schedule.css" %}">#}
{#  <link rel="stylesheet" href="{% static "main/npm/css/selectize.default.css" %}">#}
{#{% endblock %}#}
{% block title %}Расписание{% endblock %}
{% load django_bootstrap_breadcrumbs %}
{% block breadcrumbs %}
  {{ block.super }}
  {% breadcrumb 'Расписание' "schedule:index" %}
{% endblock %}
{% block content %}
  {% render_breadcrumbs %}
  <section class="container-fluid flex-grow">

    <form action="{% url "schedule:index_beta" %}" method="post">
      {% csrf_token %}
      <div class="form-group">
        {{ form.category.errors }}
        {% for radio in form.category %}
          <div class="form-check form-check-inline">
            {{ radio }}
          </div>
        {% endfor %}
      </div>
      <div class="form-row">
        <div class="form-group col-md-6 col-lg-3">
          {{ form.group.errors }}
          {{ form.group.label_tag }}
          {{ form.group }}
        </div>
        <div class="form-group col-md-6 col-lg-3">
          {{ form.teacher.errors }}
          {{ form.teacher.label_tag }}
          {{ form.teacher }}
        </div>
        <div class="form-group col-md-6 col-lg-3">
          {{ form.room.errors }}
          {{ form.room.label_tag }}
          {{ form.room }}
        </div>
      </div>
    </form>
    <div class="container">
    <h3>{{ group }} {{ category }}</h3>
      {% for p in periods %}
        <p>{{ p }}</p>
      {% endfor %}
    </div>

  </section>
{% endblock %}
{% block js %}
  {{ form.media }}
{% endblock %}

django/schedule/templates/schedule/week.html
{% if week_type != 'exam' %}
  <div class="table-responsive">
    <table class="table table-bordered table-sm" id="my_table">
      <tbody>
      {% for dd in periods.values %}
        <th id="day{{ forloop.counter }}" rowspan="7"><span>
      {% if forloop.counter == 1 %}ПОНЕДЕЛЬНИК
      {% elif forloop.counter == 2 %}ВТОРНИК
      {% elif forloop.counter == 3 %}СРЕДА
      {% elif forloop.counter == 4 %}ЧЕТВЕРГ
      {% elif forloop.counter == 5 %}ПЯТНИЦА
      {% elif forloop.counter == 6 %}СУББОТА
      {% endif %}
    </span></th>
        {% for d in dd.values %}
          <tr>
            <td>
              {% if forloop.counter == 1 %}1 09:00 10:30
              {% elif forloop.counter == 2 %}2 10:40 12:10
              {% elif forloop.counter == 3 %}3 13:10 14:40
              {% elif forloop.counter == 4 %}4 14:50 16:20
              {% elif forloop.counter == 5 %}5 16:30 18:00
              {% elif forloop.counter == 6 %}6 18:10 19:40
              {% endif %}
            </td>
            <td>{{ d.name }}</td>
            <td>{{ d.category }}</td>
            {% if category == 'g' or category == 'r' %}
              <td>{{ d.teacher }}</td>{% endif %}
            {% if category == 't' or category == 'r' %}
              <td>{{ d.groups }}</td>{% endif %}
            {% if category == 'g' or category == 't' %}
              <td id="room">{{ d.room }}</td>{% endif %}
          </tr>
        {% endfor %}
      {% endfor %}
      </tbody>
    </table>
  </div>
{% else %}
  <div class="table-responsive">
    <table class="table table-bordered">
      <tbody>
      {% for p in periods %}
        <tr>
          <td>{{ p.m_day }}</td>
          <td>{{ p.time }}</td>
          <td>{{ p.category }}</td>
          <td>{{ p.name }}</td>
          {% if category == 'g' or category == 'r' %}
            <td>{{ p.teachers.first }}</td>
          {% endif %}
          {% if category == 't' or category == 'r' %}
            <td>{{ p.group }}</td>
          {% endif %}
          {% if category == 'g' or category == 't' %}
            <td id="room">{{ p.rooms.first }}</td>
          {% endif %}
        </tr>
        </tr>
      {% endfor %}
      </tbody>
    </table>
  </div>
{% endif %}
{#обновлено: {{ upd_date }}#}

django/schedule/templates/schedule/week_mag_class.html
{% if week_type != 'exam' %}
  <div class="table-responsive">
    <table class="table table-bordered table-sm" id="my_table">
      <tbody>
      {% for dd in periods.values %}
        <th id="day{{ forloop.counter }}" rowspan="10"><span>
      {% if forloop.counter == 1 %}ПОНЕДЕЛЬНИК
      {% elif forloop.counter == 2 %}ВТОРНИК
      {% elif forloop.counter == 3 %}СРЕДА
      {% elif forloop.counter == 4 %}ЧЕТВЕРГ
      {% elif forloop.counter == 5 %}ПЯТНИЦА
      {% elif forloop.counter == 6 %}СУББОТА
      {% endif %}
    </span></th>
        {% for d in dd.values %}
          <tr>
            <td>
              {% if forloop.counter == 1 %}1 09:00 10:30
              {% elif forloop.counter == 2 %}2 10:40 12:10
              {% elif forloop.counter == 3 %}3 13:10 14:40
              {% elif forloop.counter == 4 %}4 14:50 16:20
              {% elif forloop.counter == 5 %}5 16:30 18:00
              {% elif forloop.counter == 6 %}6 18:10 19:40
              {% elif forloop.counter == 7 %}7 19:50 21:20
              {% elif forloop.counter == 8 %}7 18:30 20:00
              {% elif forloop.counter == 9 %}8 20:10 19:40
              {% endif %}
            </td>
            <td><div>{{ d.name }}</div></td>
            <td><div>{{ d.category }}</div></td>
            {% if category == 'g' or category == 'r' %}
              <td><div>{{ d.teacher }}</div></td>{% endif %}
            {% if category == 't' or category == 'r' %}
              <td><div>{{ d.groups }}</div></td>{% endif %}
            {% if category == 'g' or category == 't' %}
              <td id="room"><div>{{ d.room }}</div></td>{% endif %}
          </tr>
        {% endfor %}
      {% endfor %}
      </tbody>
    </table>
  </div>
{% else %}
  <div class="table-responsive">
    <table class="table table-bordered">
      <tbody>
      {% for p in periods %}
        <tr>
          <td>{{ p.m_day }}</td>
          <td>{{ p.time }}</td>
          <td>{{ p.category }}</td>
          <td>{{ p.name }}</td>
          {% if category == 'g' or category == 'r' %}
            <td>{{ p.teachers.first }}</td>
          {% endif %}
          {% if category == 't' or category == 'r' %}
            <td>{{ p.group }}</td>
          {% endif %}
          {% if category == 'g' or category == 't' %}
            <td id="room">{{ p.rooms.first }}</td>
          {% endif %}
        </tr>
      {% endfor %}
      </tbody>
    </table>
  </div>
{% endif %}
{#обновлено: {{ upd_date }}#}